#!/usr/bin/env python

import sys
try:  
	import pygtk  
	pygtk.require("2.0")  
except:  
	pass  
try:  
	import gtk  
	import gtk.glade  
	from subprocess import call
except:  
	print("GTK Not Availible")
	sys.exit(1)

import os
import shlex, subprocess
import ConfigParser
import gobject
import re

#print subprocess.Popen(shlex.split('command -v VBoxManages >/dev/null && echo "command1 Found" || echo "command1 Not Found"'), stdout=subprocess.PIPE).communicate()[0] # dont work ; problem with "command"
#http://www.cyberciti.biz/faq/unix-linux-shell-find-out-posixcommand-exists-or-not/

if len(re.findall('(lxc)',(subprocess.Popen(shlex.split('rpm -qa'), stdout=subprocess.PIPE).communicate()[0]))):
	MAX_LXC_NODES = len(re.findall('(vm[0-9]+)',(subprocess.Popen(shlex.split('lxc-ls'), stdout=subprocess.PIPE).communicate()[0]).strip()))
else:
	MAX_LXC_NODES = 0
#len((subprocess.Popen(shlex.split('lxc-ls'), stdout=subprocess.PIPE).communicate()[0]).strip().split()) #check the number of already created lxc containers
if len(re.findall('(VirtualBox)',(subprocess.Popen(shlex.split('rpm -qa'), stdout=subprocess.PIPE).communicate()[0]))):
	MAX_VBOX_NODES = len(re.findall('"(vm[0-9]+)"',subprocess.Popen(shlex.split('VBoxManage list vms'), stdout=subprocess.PIPE).communicate()[0])) # VBoxManage list vms | grep "vm" | awk 'BEGIN {i=0} {i=i+1} END {print i}'
else:
	MAX_VBOX_NODES = 0	

if len(re.findall('(openvpn)',(subprocess.Popen(shlex.split('rpm -qa'), stdout=subprocess.PIPE).communicate()[0]))):
	MAX_VPN_NODES = 1 # currently internal network settings consider only one macvhine connected through vpn
else:
	MAX_VPN_NODES = 0	

MIN_PORT_NO = 500 #
MAX_PORT_NO = 800 #
if os.path.isdir('../../ns-3.9-pyviz'): MAIN_NS_DIR = "ns-3.9-pyviz"
elif os.path.isdir('../../ns-3.9'): MAIN_NS_DIR = "ns-3.9"
else: MAIN_NS_DIR = "ns-3.10"


class SimToolsApi(object):       
	def __init__(self):
	    self.builder = gtk.Builder()
	    self.builder.add_from_file("sim-tools-api.glade")
	    self.builder.connect_signals({ "gtk_main_quit" : gtk.main_quit, 
				      "start_button_clicked_cb" : self.start_simulation,
				      #"stop_button_clicked_cb" : self.stop_button_clicked_cb 
				      "load_filechooserbutton_file_set_cb" : self.load_configuration,
				      "netanim_checkbutton_toggled_cb" : self.netanim_toggled,
				      "vpn_info_button_clicked_cb" : self.vpn_info,
				      "vbox_conf_button_clicked_cb" : self.configure_vbox,
				      "lxc_conf_button_clicked_cb" : self.configure_lxc,
				      "clean_button_clicked_cb" : self.clean_environment,
				      #"load_filechooserbutton_selection_changed_cb" : self.load_filechooserbutton_selection_changed_cb,
				      #"select_filechooserbutton_file_set_cb" :  self.select_filechooserbutton_file_set_cb,
				      #"select_filechooserbutton_selection_changed_cb" : self.select_filechooserbutton_selection_changed_cb
 					})#,

            user = subprocess.Popen(shlex.split('whoami'), stdout=subprocess.PIPE).communicate()[0].strip()
	    #self.user_when_root = subprocess.Popen(shlex.split('echo $USER'), stdout=subprocess.PIPE, shell=True).communicate()[0] - to nie dizala zmienna user nie zawsze jest ustawiona
	    if user == "root":
	       print "Run without root privileges!!!!"
	       quit()

	    self.window = self.builder.get_object("main_window")
            self.start_button = self.builder.get_object("start_button")
            #self.start_button.set_sensitive(False)

            self.load_button = self.builder.get_object("load_button")
            self.select_button = self.builder.get_object("select_button")
	
	    self.main_radiobutton = self.builder.get_object("main_radiobutton")
	    self.waf_radiobutton = self.builder.get_object("waf_radiobutton")
	    #self.if_combo = self.builder.get_object("if_combobox")
	    #self.lxc_combo = self.builder.get_object("lxc_combobox")

            self.select_filechooserbutton = self.builder.get_object("select_filechooserbutton")
	    #self.load_filechooserbutton.set_current_folder('.')
	    #http://www.pygtk.org/pygtk2tutorial/sec-FileChoosers.html - filter through file extensions
	    f_c = gtk.FileFilter()
            f_c.set_name("C++ files")
	    f_c.add_pattern("*.c")
	    f_c.add_pattern("*.cc")
	    f_all = gtk.FileFilter()
            f_all.set_name("All files")
            f_all.add_pattern("*")
	    self.select_filechooserbutton.add_filter(f_c)
	    self.select_filechooserbutton.add_filter(f_all)
            self.select_filechooserbutton.set_filter(f_c)

            self.load_filechooserbutton = self.builder.get_object("load_filechooserbutton")
	    self.load_filechooserbutton.set_title("Load configuration file")
	    f_conf = gtk.FileFilter()
            f_conf.set_name("Config files")
	    f_conf.add_pattern("*.conf")
	    f_conf.add_pattern("*.config")
	    self.load_filechooserbutton.add_filter(f_conf)
	    self.load_filechooserbutton.add_filter(f_all)
            self.load_filechooserbutton.set_filter(f_conf)
	    
	    self.select_filechooserbutton.set_title("Load simulation scenario file")
	    self.select_filechooserbutton.set_current_folder('../../'+MAIN_NS_DIR+'/scratch')
		
            self.config = ConfigParser.RawConfigParser()

            self.lxc_spin = self.builder.get_object("lxc_spinbutton")
            _adj = gtk.Adjustment(3.0, 0.0, MAX_LXC_NODES, 1.0, 1.0, 0)
            self.lxc_spin.set_adjustment(_adj)


            self.vbox_spin = self.builder.get_object("vbox_spinbutton")
            _adj = gtk.Adjustment(2.0, 0.0, MAX_VBOX_NODES, 1.0, 1.0, 0)
            self.vbox_spin.set_adjustment(_adj)

            self.vpn_spin = self.builder.get_object("vpn_spinbutton")
            _adj = gtk.Adjustment(1.0, 0.0, MAX_VPN_NODES, 1.0, 1.0, 0)
            self.vpn_spin.set_adjustment(_adj)

            self.pyviz_checkbutton = self.builder.get_object("pyviz_checkbutton")
            self.netanim_checkbutton = self.builder.get_object("netanim_checkbutton")

            self.port_spin = self.builder.get_object("port_spinbutton")
	    #set_combobox_model_from_list (self.port_spin, [str(i) for i in range(MIN_PORT_NO,MAX_PORT_NO+1)])
            _adj = gtk.Adjustment(700.0, MIN_PORT_NO, MAX_PORT_NO, 1.0, 1.0, 0)
            self.port_spin.set_adjustment(_adj)
	    self.port_spin.set_sensitive(False)

	    self.vpn_info_button = self.builder.get_object("vpn_info_button")

	    self.clean_button = self.builder.get_object("clean_button")

	    self.window.set_position (gtk.WIN_POS_CENTER)
	    gobject.timeout_add(5000, self.window.show)
	    #self.window.show()
	    #self.all = builder.get_objects()
            #self.all({"main_window" :}).show()

	def quit(self, widget):
	    sys.exit(0)

	def start_simulation(self, widget):
	    if (self.load_filechooserbutton.get_filename()) and (self.select_filechooserbutton.get_filename()):
  	       #overwrite config file
	       pyviz = "true"
	       port = 0
	       if self.pyviz_checkbutton.get_active(): pyviz = "true"
	       else: pyviz = "false"
	       if self.netanim_checkbutton.get_active(): port = self.port_spin.get_value_as_int()
	       else: port = 0
	       self.config.set("main", "lxc_no", self.lxc_spin.get_value_as_int())
	       self.config.set("main", "vbox_no", self.vbox_spin.get_value_as_int())
	       self.config.set("main", "vpn_no", self.vpn_spin.get_value_as_int())
	       self.config.set("main", "pyviz", pyviz)
	       self.config.set("main", "port", port)
	       with open('tmp.conf', 'w') as configfile:
                    self.config.write(configfile)
	       #
	       #conf_file = self.load_filechooserbutton.get_filename()
	       #tmp_conf = conf_file.split('/')
	       sim_scenario = self.select_filechooserbutton.get_filename()
	       tmp_sim = sim_scenario.split('/')
	       tmp_sim = tmp_sim[-1].split('.')
	       
	       if self.waf_radiobutton.get_active():
	          command_line = 'gnome-terminal -t "Sim-tools-terminal - main simulation" -e "su -c \'./main ' + tmp_sim[0] + ' tmp.conf false; echo Press any key to exit; read x\'" --hide-menubar'
		  #print command_line
		  args = shlex.split(command_line)
	       else:
	          command_line = 'gnome-terminal -t "Sim-tools-terminal - main simulation" -e "su -c \'./main ' + tmp_sim[0] + ' tmp.conf; echo Press any key to exit; read x\'" --hide-menubar'
		  #print command_line
		  args = shlex.split(command_line)
		  #os.system('gnome-terminal --title "Sim-tools-terminal - main simulation" --command "su -c \'./main ' + tmp_sim[0] + ' tmp.conf; echo press ENTER to close this window; read x\'"')
	       p = subprocess.Popen(args)
	    else:
		# http://faq.pygtk.org/index.py?req=show&file=faq10.009.htp
                #gtk.MessageDialog(parent, options, type, buttons, message)
		self.show_info_message("""Configuration or scenario file not selected!""")

	def clean_environment(self, widget):
	    command_line = 'gnome-terminal -t "Additional clearing" -e "su -c \'./vms_stop tmp.conf; ./config_del tmp.conf; echo Press any key to exit; read x\'" --hide-menubar'
	    args = shlex.split(command_line)
	    p = subprocess.Popen(args)

	def load_configuration(self, widget):
	    self.config.read(self.load_filechooserbutton.get_filename())
	    lxc_no = self.config.get("main", "lxc_no").strip().split()
	    vbox_no = self.config.get("main", "vbox_no").strip().split()
	    vpn_no = self.config.get("main", "vpn_no").strip().split()
	    pyviz = self.config.get("main", "pyviz").strip().split()
	    port = self.config.get("main", "port").strip().split()
	    #print pyviz[0] + ', ' + port[0]
	    if pyviz[0].lower() == "true":
               self.pyviz_checkbutton.set_active(True) 
	    else:
	       self.pyviz_checkbutton.set_active(False) 
	    if int(port[0]) > 0:
               self.netanim_checkbutton.set_active(True) 
	       self.port_spin.set_active(int(port[0])-MIN_PORT_NO)
	    else:
               self.netanim_checkbutton.set_active(False)
            self.lxc_spin.set_value(int(lxc_no[0]))
            self.vbox_spin.set_value(int(vbox_no[0]))
            self.vpn_spin.set_value(int(vpn_no[0]))

	def netanim_toggled(self, widget):	    
	    if self.netanim_checkbutton.get_active():
	        self.port_spin.set_sensitive(True)
	    	if self.load_filechooserbutton.get_filename():
		   port = self.config.get("main", "port").strip().split()
               	   if (int(port[0])>MIN_PORT_NO and int(port[0])<MAX_PORT_NO+1): self.port_spin.set_value(int(port[0]))
		   else: self.port_spin.set_value(700)
	    	else:
               	   self.port_spin.set_value(700)
	    else:
	        self.port_spin.set_sensitive(False)

	def vpn_info(self, widget):	    
            self.show_info_message("""Firewall setings described for this version of Simulation-tools\ndon't support more than one vpn connection.""")

	def configure_vbox(self, widget):
            from config_vbox import ConfVBoxApi	 
            app = ConfVBoxApi(self)
	    #builder = gtk.Builder()
	    #builder.add_from_file("vbox_generate_v4.glade")
	    #window = builder.get_object("config_vbox_window")
	    #window.show()

	def configure_lxc(self, widget):
            from config_lxc import ConflxcApi	 
            app = ConflxcApi(self)
	    #pass

	def on_confvboxapi_quit(self, widget):
	    if len(re.findall('(VirtualBox)',(subprocess.Popen(shlex.split('rpm -qa'), stdout=subprocess.PIPE).communicate()[0]))):
	    	MAX_VBOX_NODES = len(re.findall('"(vm[0-9]+)"',subprocess.Popen(shlex.split('VBoxManage list vms'), stdout=subprocess.PIPE).communicate()[0]))
		self.vbox_spin.set_range(0, MAX_VBOX_NODES)
		self.vbox_spin.set_value(MAX_VBOX_NODES)

	def on_conflxcapi_quit(self, widget):
	    if len(re.findall('(lxc)',(subprocess.Popen(shlex.split('rpm -qa'), stdout=subprocess.PIPE).communicate()[0]))):
	    	MAX_LXC_NODES = len(re.findall('(vm[0-9]+)',(subprocess.Popen(shlex.split('lxc-ls'), stdout=subprocess.PIPE).communicate()[0]).strip()))
		self.lxc_spin.set_range(0, MAX_LXC_NODES)
		self.lxc_spin.set_value(MAX_LXC_NODES)

	def show_info_message(self, mess):	    
 	    message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_NONE, mess)
 	    message.add_button(gtk.STOCK_QUIT, gtk.RESPONSE_CLOSE)
 	    resp = message.run()
 	    if resp == gtk.RESPONSE_CLOSE:
		message.destroy()

   	def app_close (self):
    	# cleanup here -- needed this method to close databases etc.,
     	# for some reason __del__ was not called on them
     	    if gtk.main_level() > 0: # needed if app_close is called explicitly
       		gtk.main_quit()



def create_app ():
   try:
     globals()['my_app'] = SimToolsApi ()
   except: # application initiation failed
     gtk.main_quit()
     raise
   #splash.destroy()

def main_init ():
   splash = gtk.Window (gtk.WINDOW_TOPLEVEL)
   # create splash contents here
   splash.realize()
   splash.window.set_type_hint (gtk.gdk.WINDOW_TYPE_HINT_SPLASHSCREEN)
   # needed because the window_type hint above does not work on Win32 :-/
   splash.set_decorated (False)
   splash.set_position (gtk.WIN_POS_CENTER)
   splash.show()

   hbox = gtk.HBox()
   hbox.show()
   splash.add(hbox)
   pixbufanim = gtk.gdk.PixbufAnimation("startup.jpg")
   image = gtk.Image()
   image.set_from_animation(pixbufanim)
   image.show()

   # a button to contain the image widget
   button = gtk.Button()
   button.add(image)
   button.show()
   hbox.pack_start(button)

   while gtk.events_pending():
      gtk.main_iteration()

   gobject.timeout_add(5000, splash.hide)
   gobject.idle_add (create_app)
   gtk.main()
   if my_app:
     # some method asked called gtk.main_quit
     my_app.app_close()


if __name__ == "__main__":
	main_init ()
