#!/usr/bin/env python

try:  
	import pygtk  
	pygtk.require("2.0")  
except:  
	pass  
try:  
	import gtk  
	import gtk.glade  
	from subprocess import call
except:  
	print("GTK Not Availible")
	sys.exit(1)

import sys
import os
import shlex, subprocess
import ConfigParser
import gobject
import re

#BRIDGE_BASENAME = "b"
#LXC_BASENAME = "vm"
#IP0_BASE_ADDRESS_MASK = "10.125.11.100/24"
TOOLS_DIR = "lxc/tools"


def set_combobox_model_from_list (cb, items):
        """Setup a ComboBox or ComboBoxEntry based on a list of integers
	       info: http://faq.pygtk.org/index.py?req=show&file=faq16.008.htp ,
	             http://faq.pygtk.org/index.py?query=prepend&querytype=simple&req=search"""    
	if items:
	    model = cb.get_model()
	    if model:
	       cb.set_model(None)
	       model.clear()
               cb.clear()
	    else:
	       model = gtk.ListStore(type(items[0]))
	       #model = gtk.TreeStore(type(items[0]))
	       #model = gtk.TreeModel()
            for i in items:
               model.append([i])
            cb.set_model(model)
    	    if type(cb) == gtk.ComboBoxEntry:
	       cb.set_text_column(0)
            elif type(cb) == gtk.ComboBox:
               cell = gtk.CellRendererText()
               cb.pack_start(cell, True)
               cb.add_attribute(cell, 'text', 0)
		

def get_active_combobox_value (widget):
	model = widget.get_model()
	it = widget.get_active_iter()
	return model.get_value(it, 0)
	#model = combobox.get_model()
	#active = combobox.get_active()
	#if active < 0:
   	#   return None
	#return model[active][0]




class ConflxcApi(object):       
	def __init__(self, *args, **kwargs):
            if len(args) == 1:  self.ext = True;
            else:               self.ext = False;
	    self.builder = gtk.Builder()
	    self.builder.add_from_file("lxc_config.glade")
	    if self.ext==False:
	    	self.builder.connect_signals({ "gtk_main_quit" : gtk.main_quit,
					       "gen_do_button_clicked_cb" : self.gen_do_button_do,
					       "del_do_button_clicked_cb" : self.del_do_button_do,
					       "update_start_button_clicked_cb" : self.start_update
					       #"gen_sel_combobox_button_press_event_cb" : self.gen_sel_update_list
 						})#,
	    else:
	        self.builder.connect_signals({ "gtk_main_quit" : self.quit,
					       "gen_do_button_clicked_cb" : self.gen_do_button_do,
					       "del_do_button_clicked_cb" : self.del_do_button_do,
					       "update_start_button_clicked_cb" : self.start_update
					       #"gen_sel_combobox_button_press_event_cb" : self.gen_sel_update_list
 					})#,
                self.parent = args[0]
		self.parent.window.set_sensitive(False)
   
            self.window = self.builder.get_object("config_lxc_window")
	    #Generate notepad
	    self.gen_config_filechooserbutton = self.builder.get_object("gen_filechooserbutton")
	    self.gen_clone_dir_tree_checkbutton = self.builder.get_object("gen_clone_dir_tree_checkbutton")

	    self.gen_from_entry = self.builder.get_object("gen_from_entry")
	    self.gen_to_entry = self.builder.get_object("gen_to_entry")
	    self.gen_do_button = self.builder.get_object("gen_do_button")

	    #Delete notepad
	    self.del_from_entry = self.builder.get_object("del_from_entry")
	    self.del_to_entry = self.builder.get_object("del_to_entry")
	    self.del_do_button = self.builder.get_object("del_do_button")

	    #Update notepad
	    self.update_if_combo = self.builder.get_object("update_interface_combobox")
	    ##Find interfaces
	    p1 = subprocess.Popen(["ifconfig"], stdout=subprocess.PIPE)
            p2 = subprocess.Popen(["grep", "Link encap:"], stdin=p1.stdout, stdout=subprocess.PIPE)
            p3 = subprocess.Popen(shlex.split("awk '{print $1}'"), stdin=p2.stdout, stdout=subprocess.PIPE)
            p1.stdout.close()  # Allow p1 to receive a SIGPIPE if p2 exits.
            p2.stdout.close()  # Allow p2 to receive a SIGPIPE if p3 exits.
	    interface_list = (p3.communicate()[0]).strip().split()
	    ##
	    set_combobox_model_from_list (self.update_if_combo, interface_list)
            self.update_if_combo.set_active(0)
	    ##Find all lxc
	    self.update_lxc_name_combo = self.builder.get_object("update_lxc_name_combobox")
	    set_combobox_model_from_list (self.update_lxc_name_combo, (subprocess.Popen(shlex.split('lxc-ls'), stdout=subprocess.PIPE).communicate()[0]).strip().split() )
            self.update_lxc_name_combo.set_active(0)
	    self.update_start_button = self.builder.get_object("update_start_button")

	    #Info notepad
	    self.conf_info_textview = self.builder.get_object("conf_info_textview")
	    buf = gtk.TextBuffer()
	    buf.set_text("""To use this tool at lest one lxc\nmachine should be already created as\nit was described in lxc/README file.""")
	    self.conf_info_textview.set_buffer(buf)

            self.config = ConfigParser.RawConfigParser() # in python 3k allow_no_value=True)
	    #self.config.read('../config.conf')

            #self.base_lxc_config = ConfigParser.RawConfigParser(allow_no_value=True)
	    #self.base_lxc_config.read(self.gen_config_filechooserbutton.get_filename())

	    self.window.show()

	def quit(self, widget):
	    self.parent.window.set_sensitive(True)
	    self.parent.on_conflxcapi_quit(self)

	def gen_do_button_do(self, widget):
	    if (self.gen_from_entry.get_text()) and (self.gen_to_entry.get_text()) and (self.gen_config_filechooserbutton.get_filename()):
		
               base_lxc_conf_file = self.gen_config_filechooserbutton.get_filename()

	       self.config.read(TOOLS_DIR+"/lxc_config.conf")
	       lxc_basename  = self.config.get("lxc_config", "lxc_basename").strip().split()
	       bridge_basename = self.config.get("lxc_config", "lxc_bridge_basename").strip().split()
	       ip0_addr_mask = self.config.get("lxc_config", "ip0_base_addr_mask").strip().split()

	       from_vm_number = self.gen_from_entry.get_text()
	       to_vm_number = self.gen_to_entry.get_text()
		
	       if self.gen_clone_dir_tree_checkbutton.get_active():
	            command_line = 'gnome-terminal -t "lxc manager" -e "su -c \'./gen_lxc_multiple_rootfs '+ base_lxc_conf_file +' '+ lxc_basename[0] +' '+ bridge_basename[0] +' '+ ip0_addr_mask[0] +' '+ from_vm_number +' '+ to_vm_number +'; echo Press any key to exit; read x\'" --hide-menubar'
	       else:
	            command_line = 'gnome-terminal -t "lxc manager" -e "su -c \'./gen_lxc '+ base_lxc_conf_file +' '+ lxc_basename[0] +' '+ bridge_basename[0] +' '+ ip0_addr_mask[0] +' '+ from_vm_number +' '+ to_vm_number +'; echo Press any key to exit; read x\'" --hide-menubar'

	       #print command_line
	       args = shlex.split(command_line)
	       p = subprocess.Popen(args,cwd=(os.getcwd()+'/'+TOOLS_DIR))

	       self.config.set("lxc_config", "base_lxc_conf_path", base_lxc_conf_file)
	       with open(TOOLS_DIR+"/lxc_config.conf", 'w') as configfile:
                    self.config.write(configfile)

	    else:
                self.show_info_message("""The virtual machine config file or/and range not filled!""")

	def del_do_button_do(self, widget):
	    self.config.read(TOOLS_DIR+"/lxc_config.conf")
            base_lxc_conf_file = self.config.get("lxc_config", "base_lxc_conf_path").strip().split()
	    if (self.del_from_entry.get_text()) and (self.del_to_entry.get_text()) and (base_lxc_conf_file):

	       lxc_basename  = self.config.get("lxc_config", "lxc_basename").strip().split()
	       ip0_addr_mask = self.config.get("lxc_config", "ip0_base_addr_mask").strip().split()

	       from_vm_number = self.del_from_entry.get_text()
	       to_vm_number = self.del_to_entry.get_text()
                                 
	       command_line = 'gnome-terminal -t "lxc manager" -e "su -c \'./del_lxc '+ base_lxc_conf_file[0] +' '+ lxc_basename[0] +' '+ ip0_addr_mask[0] +' '+ from_vm_number +' '+ to_vm_number +'; echo Press any key to exit; read x\'" --hide-menubar'

	       #print command_line
	       args = shlex.split(command_line)
	       p = subprocess.Popen(args,cwd=(os.getcwd()+'/'+TOOLS_DIR))
	    else:
                self.show_info_message("""Nothing to delete or/and range not filled!""")


	def start_update(self, widget):
	    if 1: #(self.update_lxc_name_combo.get_active()) and (self.update_if_combo.get_active()):
	       lxc_name = get_active_combobox_value(self.update_lxc_name_combo)
               interface = get_active_combobox_value(self.update_if_combo)
                
	       command_line = 'gnome-terminal -t "lxc manager" -e "su -c \'./vms_update '+ lxc_name +' '+ interface +'; echo Press any key to exit; read x\'" --hide-menubar'

	       #print command_line
	       args = shlex.split(command_line)
	       p = subprocess.Popen(args,cwd=(os.getcwd()))#+'/'+TOOLS_DIR))
	    else:
                self.show_info_message("""Nothing to update or/and no interface selected!""")

	#def gen_sel_update_list(self, widget):
	 #   set_combobox_model_from_list (self.gen_sel_combo, re.findall('"([a-zA-Z0-9\_?]+)+"',subprocess.Popen(shlex.split('lxcManage list vms'), stdout=subprocess.PIPE).communicate()[0]))

	def show_info_message(self, mess):	    
 	    message = gtk.MessageDialog(None, gtk.DIALOG_MODAL, gtk.MESSAGE_INFO, gtk.BUTTONS_NONE, mess)
 	    message.add_button(gtk.STOCK_QUIT, gtk.RESPONSE_CLOSE)
 	    resp = message.run()
 	    if resp == gtk.RESPONSE_CLOSE:
		message.destroy()
		

if __name__ == "__main__":
	app = ConflxcApi()
	gtk.main()



